#!/usr/bin/perl

use strict;
use Test::More tests => 23;
use FDN::Common::Config;

$FDN::Common::Config::CONFIG_ROOT = 't/';

# 1
BEGIN { use_ok('FDN::Web::Session'); }

# 2
$FDN::Web::Session::debug=1;
my $sess = new_session('test');
ok ( defined $sess, 'new');

# 3
is ( ref($sess), 'HASH', 'new');

# 4
is ( $sess->{type}, 'test', 'new');

# 5
like ( $sess->{name}, qr/^test/, 'new');

my $name = $sess->{name};
my $type = $sess->{type};
my $res;
$sess->{content}->{a} = 1;
$res = store_session($sess);

# 6
is ( $res, $name, 'store' );

$sess = retrieve_session($type, $name);

# 7
ok ( defined $sess, 'retrieve');

# 8
is ( ref($sess), 'HASH', 'retrieve');

# 9
ok ( defined $sess->{type}, 'retrieve');

# 10
is ( $sess->{type}, $type, 'retrieve');

# 11
ok ( defined $sess->{name}, 'retrieve');

# 12
is ( $sess->{name}, $name, 'retrieve');

# 13
ok ( defined $sess->{content}, 'retrieve');

# 14
is ( ref $sess->{content}, 'HASH', 'retrieve' );

# 15
ok ( defined $sess->{content}->{a}, 'retrieve' );

# 16
is ( $sess->{content}->{a}, 1, 'retrieve' );

sleep(1);

# 17
ok ( refresh_session($type, $name), 'refresh' );

sleep(1);

# 18
ok ( refresh_session($type, $name), 'refresh' );

sleep(1);
$sess = retrieve_session($type, $name);

# 19
ok ( defined $sess, 'refresh' );

sleep(3);
$sess = retrieve_session($type, $name);

# 20
ok ( ! defined $sess, 'refresh' );

$sess = new_session('test');
$name = $sess->{name};
$type = $sess->{type};
$sess->{content}->{a} = 1;
$res = store_session($sess);

# 21
is ( $res, $name, 'store' );

# 22
ok ( close_session($type, $name), 'close' );

$sess = retrieve_session($type, $name);

# 23
ok ( ! defined $sess, 'close' );






